/*
 * JBoss, Home of Professional Open Source
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.test.cmp2.batchcascadedelete.test;

import org.jboss.test.JBossTestCase;
import org.jboss.test.cmp2.batchcascadedelete.ejb.Child;
import org.jboss.test.cmp2.batchcascadedelete.ejb.ChildHome;
import org.jboss.test.cmp2.batchcascadedelete.ejb.ChildUtil;
import org.jboss.test.cmp2.batchcascadedelete.ejb.GrandchildHome;
import org.jboss.test.cmp2.batchcascadedelete.ejb.GrandchildUtil;
import org.jboss.test.cmp2.batchcascadedelete.ejb.Parent;
import org.jboss.test.cmp2.batchcascadedelete.ejb.ParentHome;
import org.jboss.test.cmp2.batchcascadedelete.ejb.ParentUtil;
import junit.framework.Test;

/**
 * @author <a href="mailto:alex@jboss.org">Alexey Loubyansky</a>
 * @version <tt>$Revision: 1.1.2.1 $</tt>
 */
public class BatchCascadeDeleteUnitTestCase
   extends JBossTestCase
{
   /**
    * Constructor for the JBossTestCase object
    *
    * @param name Test case name
    */
   public BatchCascadeDeleteUnitTestCase(String name)
   {
      super(name);
   }

   public static Test suite() throws Exception
   {
      return JBossTestCase.getDeploySetup(BatchCascadeDeleteUnitTestCase.class, "cmp2-batchcascadedelete.jar");
   }

   public void testCase4540() throws Exception
   {
      ParentHome parentHome = ParentUtil.getHome();
      Parent parent = parentHome.create("parent");

      ChildHome childHome = ChildUtil.getHome();
      Child child = childHome.create( parent, "child");

      GrandchildHome grandchildHome = GrandchildUtil.getHome();

      // If you comment out the next line, then the call to child.remove() works fine.
      grandchildHome.create(child.getId(), "grandchild");

      // this is the test for non-null foreign key
      child.remove();
   }
}
